#ifndef __HAVE_PATCH_H__
#define __HAVE_PATCH_H__

#define PATCHOPTIONS 18

#ifdef OLD_ISOPTION

#define OPER_CANSET_K		1
#define OPER_CANSET_X		2
#define OPER_CANJOIN_I		3
#define OPER_CANJOIN_K		4
#define OPER_CANJOIN_B		5
#define OPER_CANJOIN_L		6
#define X_CANKILL_K             7
#define X_CANDEOP_K             8
#define X_CANKICK_K             9
#define USE_FAKEHOST		10
#define OPER_CANSEND_N		11
#define OPER_CANSEND_M		12
#define OPER_SERVMODE		13
#define OPER_DYNHOST		14
#define USER_SETHOST		15
#define OPER_CANFLOOD           16
#define OPER_NOLAG              17
#define OPER_NETRIDE		18

#else 
/* froo and Zarjazz: new IsOption macro/bitmask code */
/* Modified a bit to handle logging stuff also ++Bafi */

extern unsigned int eLine;	/* Config options */
extern unsigned int eLineL1;	/* Log level 1 */
extern unsigned int eLineL2;	/* Log level 2 */

#define IsOption(x) (eLine & (x))
#define LogOption(x) ((eLineL1 & (x)) || (eLineL2 & (x)) )

#define OPER_CANSET_K		0x00001
#define OPER_CANSET_X		0x00002
#define OPER_CANJOIN_I		0x00004
#define OPER_CANJOIN_K		0x00008
#define OPER_CANJOIN_B		0x00010
#define OPER_CANJOIN_L		0x00020
#define X_CANKILL_K             0x00040
#define X_CANDEOP_K             0x00080
#define X_CANKICK_K             0x00100
#define USE_FAKEHOST		0x00200
#define OPER_CANSEND_N		0x00400
#define OPER_CANSEND_M		0x00800
#define OPER_SERVMODE		0x01000
#define OPER_DYNHOST		0x02000
#define USER_SETHOST		0x04000
#define OPER_CANFLOOD           0x08000
#define OPER_NOLAG              0x10000
#define OPER_NETRIDE		0x20000

#endif

#define N_OPER_CANSET_K		1
#define N_OPER_CANSET_X		2
#define N_OPER_CANJOIN_I	3
#define N_OPER_CANJOIN_K	4
#define N_OPER_CANJOIN_B	5
#define N_OPER_CANJOIN_L	6
#define N_X_CANKILL_K           7
#define N_X_CANDEOP_K           8
#define N_X_CANKICK_K           9
#define N_USE_FAKEHOST		10
#define N_OPER_CANSEND_N	11
#define N_OPER_CANSEND_M	12
#define N_OPER_SERVMODE		13
#define N_OPER_DYNHOST		14
#define N_USER_SETHOST		15
#define N_OPER_CANFLOOD         16
#define N_OPER_NOLAG            17
#define N_OPER_NETRIDE		18

#define DESC_OPER_CANSET_K	" Opers can set umode +k (Channel Service)"
#define DESC_OPER_CANSET_X	"   Opers can set umode +X (Extended oper)"
#define DESC_OPER_CANJOIN_I	"           ..to join invite only channels"
#define DESC_OPER_CANJOIN_K	"                 ..to join keyed channels"
#define DESC_OPER_CANJOIN_B	"             ..to join channels if banned"
#define DESC_OPER_CANJOIN_L	"                  ..to join full channels"
#define DESC_X_CANKICK_K        "                     ..to kick +k clients"
#define DESC_X_CANDEOP_K        "                     ..to deop +k clients"
#define DESC_X_CANKILL_K        "                     ..to kill +k clients"
#define DESC_USE_FAKEHOST	"              Enable fakehosts (F: lines)"
#define DESC_OPER_CANSEND_N     " Opers can message +n channels externally"
#define DESC_OPER_CANSEND_M     "    Opers can speak on moderated channels"
#define DESC_OPER_SERVMODE	"           Opers can use servmode command"
#define DESC_OPER_DYNHOST	"  Opers can change their host dynamically"
#define DESC_USER_SETHOST	"Allow users to SETHOST passworded S:lines"
#define DESC_OPER_CANFLOOD      "        Opers will not exceed their SendQ"
#define DESC_OPER_NOLAG         " Opers have smaller penalty when flooding"
#define DESC_OPER_NETRIDE	"                        Opers can netride"
#define HEADERLINE "--------------------------------------------------------------------"
#define DGPHFILE                "demogrph_countries.txt"

#ifdef OLD_ISOPTION
extern int IsOption(int option);
extern int LogOption(int option);
#endif
extern void LogFeature(struct Client *cptr, int type, const char *fmt, ...);
extern void show_patchinfo(struct Client *cptr);
extern void *strip_mirc_colors(char *line);
extern int IsService(struct Client *cptr);
extern int m_check(struct Client *cptr, struct Client *sptr, int parc, char *parv[]);
extern int m_sethost(struct Client *cptr, struct Client *sptr, int parc, char *parv[]);
extern int m_servmode(struct Client *cptr, struct Client *sptr, int parc, char *parv[]);
extern int m_patchinfo(struct Client *cptr, struct Client *sptr, int parc, char *parv[]);
extern char *ConstructMask(char *hoststr);
extern char *PadChar(int length, int max, char ch);
extern char *GetVhostPass(char *hostmsk);

#endif /* __HAVE_PATCH_H__ */
